import Vue from 'vue'
import Router from 'vue-router'
import { normalizeURL, decode } from 'ufo'
import { interopDefault } from './utils'
import scrollBehavior from './router.scrollBehavior.js'

const _1cab7e5a = () => interopDefault(import('../pages/blog/index.vue' /* webpackChunkName: "pages/blog/index" */))
const _715019aa = () => interopDefault(import('../pages/login.vue' /* webpackChunkName: "pages/login" */))
const _30f9f828 = () => interopDefault(import('../pages/projects.vue' /* webpackChunkName: "pages/projects" */))
const _433e1ee7 = () => interopDefault(import('../pages/resources.vue' /* webpackChunkName: "pages/resources" */))
const _1500ba3e = () => interopDefault(import('../pages/blog/_id/index.vue' /* webpackChunkName: "pages/blog/_id/index" */))
const _049f5fd8 = () => interopDefault(import('../pages/index.vue' /* webpackChunkName: "pages/index" */))

const emptyFn = () => {}

Vue.use(Router)

export const routerOptions = {
  mode: 'history',
  base: '/',
  linkActiveClass: 'nuxt-link-active',
  linkExactActiveClass: 'nuxt-link-exact-active',
  scrollBehavior,

  routes: [{
    path: "/blog",
    component: _1cab7e5a,
    name: "blog"
  }, {
    path: "/login",
    component: _715019aa,
    name: "login"
  }, {
    path: "/projects",
    component: _30f9f828,
    name: "projects"
  }, {
    path: "/resources",
    component: _433e1ee7,
    name: "resources"
  }, {
    path: "/blog/:id",
    component: _1500ba3e,
    name: "blog-id"
  }, {
    path: "/",
    component: _049f5fd8,
    name: "index"
  }],

  fallback: false
}

export function createRouter (ssrContext, config) {
  const base = (config._app && config._app.basePath) || routerOptions.base
  const router = new Router({ ...routerOptions, base  })

  // TODO: remove in Nuxt 3
  const originalPush = router.push
  router.push = function push (location, onComplete = emptyFn, onAbort) {
    return originalPush.call(this, location, onComplete, onAbort)
  }

  const resolve = router.resolve.bind(router)
  router.resolve = (to, current, append) => {
    if (typeof to === 'string') {
      to = normalizeURL(to)
    }
    return resolve(to, current, append)
  }

  return router
}
